> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Project Environment Classes

> Lists environment classes of a project.

`Unary` · [`Projects`](/docs/api-reference/generated/project/overview)

Lists environment classes of a project.

Use this method to:

* View all environment classes of a project

### Examples

* List project environment classes:

  Shows all environment classes of a project.

  ```yaml theme={null}
  projectId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.ProjectService/ListProjectEnvironmentClasses
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.ProjectService/ListProjectEnvironmentClasses" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.project_pb2 as project_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = project_pb2.ListProjectEnvironmentClassesRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.project.list_project_environment_classes(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListProjectEnvironmentClassesRequestSchema } from "@gitpod/sdk/gitpod/v1/project_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListProjectEnvironmentClassesRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.project.listProjectEnvironmentClasses(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListProjectEnvironmentClassesRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.Project.ListProjectEnvironmentClasses(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListProjectEnvironmentClassesRequest`

ListProjectEnvironmentClassesRequest lists environment classes of a project.

| Field        | Type                                                    | Required | Description                                                                   |
| ------------ | ------------------------------------------------------- | -------- | ----------------------------------------------------------------------------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No       | pagination contains the pagination options for listing project policies       |
| `projectId`  | string                                                  | No       | project\_id specifies the project identifier Constraints: `string.uuid=true`. |

## Response

`gitpod.v1.ListProjectEnvironmentClassesResponse`

| Field                       | Type                                                                          | Required | Description |
| --------------------------- | ----------------------------------------------------------------------------- | -------- | ----------- |
| `pagination`                | [PaginationResponse](#type-gitpod-v1-pagination-response)                     | No       |             |
| `projectEnvironmentClasses` | array of [ProjectEnvironmentClass](#type-gitpod-v1-project-environment-class) | No       |             |

## Related types

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-project-environment-class" />

<Accordion title="ProjectEnvironmentClass">
  `gitpod.v1.ProjectEnvironmentClass`

  | Field                | Type    | Required | Description                                                                                                                          |
  | -------------------- | ------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------ |
  | `localRunner`        | boolean | No       | Use a local runner for the user                                                                                                      |
  | `environmentClassId` | string  | No       | Use a fixed environment class on a given Runner. This cannot be a local runner's environment class. Constraints: `string.uuid=true`. |
  | `order`              | integer | No       | order is the priority of this entry                                                                                                  |
</Accordion>
